function p = hasJtreeProperty(J, cliques)
% hasJtreeProperty Does this graph have the junction tree property?
% function p = hasJtreeProperty(J, cliques)

num_cliques = length(cliques);
clqSize = zeros(1, num_cliques);
sepSize = zeros(num_cliques, num_cliques);
domain = [];
for i=1:num_cliques
  domain = unique([domain cliques{i}]);
  clqSize(i) = length(cliques{i});
  for j=neighbors(J,i)
    sepSize(i,j) = length(intersect(cliques{i}, cliques{j}));
  end
end
sepSize = triu(sepSize);

p = isAcyclic(J,0) & isequal(sum(sepSize(:)), sum(clqSize)-length(domain));

